open ExtString;;
let (|>) x f = f x;;

let iter_file_lines fname f = (*     fname  f *)
  let ic = open_in fname in	 
  Enum.iter f (Std.input_lines ic); 
	close_in ic;;
  
let numerize s = (*   ,  - *)
  let letters = "ejnqrwxdsyftamcivbkulopghz" 
  and digits  = "01112223334455666777888999" in
  let mapper c = try String.sub digits (String.index letters c) 1 with Not_found->""
  in String.replace_chars mapper (String.lowercase s);;
  
let dict = Hashtbl.create 100;; (*  -  " ->    " *)
(*         *)
iter_file_lines "dictionary.txt" (fun s -> Hashtbl.add dict (numerize s) s);;

(*  find        , 
        ,   
        *)
let find str =
  Enum.init (String.length str) (fun i->String.sub str 0 (i+1)) |>
  Enum.map (fun s->List.map (fun w-> (w, String.length (numerize w))) (Hashtbl.find_all dict s)) |>
  Enum.fold (@) [];;

(*    .       . *)
let process phone = 
  (*   ,        *)
  let rec encode str res dig_used = 
    (*        ,   *)
    if str = "" then (if res<>"" then Printf.printf "%s:%s\n" phone res) else
    let vars = find str in (* ,       *)
    if vars = [] then (*   , ,  ,     *)
      (if dig_used then () else encode (String.lchop str) (res^" "^(String.sub str 0 1))  true)
    (*    ,          
         *)    
    else List.iter (fun (word,k)-> 
			encode (String.sub str k (String.length str - k)) (res ^ " " ^ word) false ) vars  in
  (*    ,   *)  
  let digits = String.replace_chars (function '0'..'9' as c-> String.of_char c |_->"") phone in
  encode digits "" false;;  
  
iter_file_lines "input.txt" process;; (*     *)